unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, FileCtrl, registry, ExtCtrls, ComCtrls, jpeg,
  PackageFormat, ToolWin, Grids, Outline, DirOutln, OleCtrls, isp3,
  BrowseDr, Buttons, Objects;

type
  TMainForm = class(TForm)
    TexturePopup: TPopupMenu;
    ExporttoBMP1: TMenuItem;
    ExporttoJPEG1: TMenuItem;
    N2: TMenuItem;
    ShowLargestMipMap1: TMenuItem;
    TiledPreview1: TMenuItem;
    MainPageControl: TPageControl;
    TabSheet1: TTabSheet;
    PackageGroupBox: TGroupBox;
    AvailPackages: TFileListBox;
    GroupBox3: TGroupBox;
    GroupList: TListBox;
    GroupBox1: TGroupBox;
    PackageVersion: TLabel;
    GroupCount: TLabel;
    TextureCount: TLabel;
    FileSize: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    btnSearch: TButton;
    edbSearch: TEdit;
    PreviewBox: TGroupBox;
    TexturePanel: TPanel;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Panel10: TPanel;
    GroupBox2: TGroupBox;
    Panel9: TPanel;
    Bevel2: TBevel;
    Label7: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    GroupBox4: TGroupBox;
    Readme: TMemo;
    Panel11: TPanel;
    Panel14: TPanel;
    PreviewUpDown: TScrollBar;
    Panel0: TPanel;
    Image0: TImage;
    PreviewDesc0: TLabel;
    Panel1: TPanel;
    Image1: TImage;
    PreviewDesc1: TLabel;
    Panel2: TPanel;
    Image2: TImage;
    PreviewDesc2: TLabel;
    Panel5: TPanel;
    Image5: TImage;
    PreviewDesc5: TLabel;
    Panel4: TPanel;
    Image4: TImage;
    PreviewDesc4: TLabel;
    Panel3: TPanel;
    Image3: TImage;
    PreviewDesc3: TLabel;
    Panel6: TPanel;
    Image6: TImage;
    PreviewDesc6: TLabel;
    Panel7: TPanel;
    Image7: TImage;
    PreviewDesc7: TLabel;
    Panel8: TPanel;
    Image8: TImage;
    PreviewDesc8: TLabel;
    GroupBox6: TGroupBox;
    Label13: TLabel;
    JPEGCompTrackBar: TTrackBar;
    Label16: TLabel;
    Label17: TLabel;
    Label15: TLabel;
    JPEGCompEdit: TEdit;
    pnlStatus: TPanel;
    Bevel1: TBevel;
    AddTextureDialog: TOpenDialog;
    CreateUTXProgressBar: TProgressBar;
    SavePackageDialog: TSaveDialog;
    Image9: TImage;
    ExitBtn: TButton;
    License: TMemo;
    ImgView: TImage;
    ImgPreference: TImage;
    Label8: TLabel;
    Label11: TLabel;
    Imgabout: TImage;
    ViewerLabel: TLabel;
    ChDirBtn: TButton;
    BrowseDlg: TdfsBrowseDirectoryDlg;
    Label10: TLabel;
    SaveDirEdit: TEdit;
    ChSaveDirBtn: TButton;
    TabSheet2: TTabSheet;
    Panel12: TPanel;
    Image10: TImage;
    Label9: TLabel;
    ExporttoPCX1: TMenuItem;
    GroupBox5: TGroupBox;
    BtnZoomIn: TBitBtn;
    BtnZoomOut: TBitBtn;
    GroupBox7: TGroupBox;
    N1: TMenuItem;
    ShowTextureDetails1: TMenuItem;
    PropertyMemo: TMemo;
    Label12: TLabel;
    Label14: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    LabelNumberofFrames: TLabel;
    LabelMinFrameRate: TLabel;
    LabelMaxFrameRate: TLabel;
    TextureName: TLabel;
    TextureDimensions: TLabel;
    TextureSize: TLabel;
    TextureMipMapCount: TLabel;
    TexturebMasked: TLabel;
    TextureIsAnimated: TLabel;
    TextureFrameCount: TLabel;
    TextureMinFramerate: TLabel;
    TextureMaxFramerate: TLabel;
    Label30: TLabel;
    TexturePackage: TLabel;
    OpenGLPanel: TPanel;
    OpenGLTimer: TTimer;
    TabSheet3: TTabSheet;
    Panel13: TPanel;
    ImgCreate: TImage;
    Label18: TLabel;
    GroupBox8: TGroupBox;
    Groups: TLabel;
    Label19: TLabel;
    GroupListBox: TListBox;
    TextureListBox: TListBox;
    AddGroupBtn: TButton;
    RemoveGroupBtn: TButton;
    RemoveTextureBtn: TButton;
    AddTextureBtn: TButton;
    ResetUTXBtn: TButton;
    TextureProperties: TGroupBox;
    Panel15: TPanel;
    CreateUTXImage: TImage;
    Panel16: TPanel;
    Image11: TImage;
    TextureDimension: TLabel;
    ShallGenerateMipMaps: TCheckBox;
    bMasked: TCheckBox;
    SaveUTXBtn: TButton;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AvailPackagesClick(Sender: TObject);
    procedure GroupListClick(Sender: TObject);
    procedure ExporttoBMP1Click(Sender: TObject);
    procedure Image0MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image5MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image6MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image7MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image8MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExporttoJPEG1Click(Sender: TObject);
    procedure TiledPreview1Click(Sender: TObject);
    procedure ShowLargestMipMap1Click(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure PreviewUpDownChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure JPEGCompTrackBarChange(Sender: TObject);
    procedure JPEGCompEditChange(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure ChDirBtnClick(Sender: TObject);
    procedure ChSaveDirBtnClick(Sender: TObject);
    procedure ExporttoPCX1Click(Sender: TObject);
    procedure ShowTextureDetails1Click(Sender: TObject);
    procedure TabSheet4Enter(Sender: TObject);
    procedure TabSheet4Exit(Sender: TObject);
    procedure TabSheet2Enter(Sender: TObject);
    procedure TabSheet2Exit(Sender: TObject);
    procedure testBtnClick(Sender: TObject);
    procedure OpenGLTimerTimer(Sender: TObject);
    procedure BtnZoomInClick(Sender: TObject);
    procedure BtnZoomOutClick(Sender: TObject);
    procedure AddGroupBtnClick(Sender: TObject);
    procedure RemoveGroupBtnClick(Sender: TObject);
    procedure ResetUTXBtnClick(Sender: TObject);
    procedure AddTextureBtnClick(Sender: TObject);
    procedure RemoveTextureBtnClick(Sender: TObject);
    procedure SaveUTXBtnClick(Sender: TObject);
    procedure TabSheet3Enter(Sender: TObject);
    procedure GroupListBoxClick(Sender: TObject);
    procedure TextureListBoxClick(Sender: TObject);
    procedure ShallGenerateMipMapsClick(Sender: TObject);
    procedure bMaskedClick(Sender: TObject);
  private
    procedure ShowHint(Sender : Tobject);
    procedure MyException(Sender: TObject; E: Exception);
    procedure UpdatePackageList;
    procedure UpdateTextureList;
    procedure DrawPreviews(const TextureIndex : integer);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
  Version = '2.2';

var
  h_Wnd         : HWND;     // Window handles for OpenGL
  h_DC          : HDC;
  h_RC          : HGLRC;
  MainForm      : TMainForm;
//  Directory     : string;
//  SaveDir       : string;
//  UTPackage     : TUTPackage; //Object of TexturePackage (Read-Only)
  IsLoaded      : Boolean;    //Package successfully loaded ?
  GroupIndex    : integer;    //Index of current group
  SelTexture    : integer;    //Index of selected-texture when using the popup
  JPEGComp      : integer;    //JPEG-Compression Quality

implementation

uses TiledPreviewDlg, FullPreviewDlg, ErrorBox, PCXctrl, PkgAux, OpenGLPreview, OpenGL, GLAux,
  AddGroupDlg, OpenPcxDlg;

{$R *.DFM}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//Open dialog and init-stuff

//Exit program
procedure TMainForm.Exit1Click(Sender: TObject);
begin
  //Finish objects
  UTPackage.Free;
  Close;
end;

// Initialise the hint handling routine
procedure TMainForm.ShowHint(Sender: TObject);
begin
  PnlStatus.Caption := '   ' + application.Hint;
end;

// Initialise the exception handling routine
procedure TMainForm.MyException(Sender: TObject; E: Exception);
begin
  frmError.lblError.caption := E.Message;
  frmError.show;
end;

//first-init-stuff
procedure TMainForm.FormCreate(Sender: TObject);
var
  Reg          : TRegistry;
  RegSuccess   : Boolean;
begin
  // Setup custom exception handler
  Application.OnException := MyException;
  btnSearch.Caption:='Package &Search';
  Application.OnHint := ShowHint;

  //Load program-registry-entries
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_CURRENT_USER;
  RegSuccess := Reg.OpenKey('Software\Topp\UTX-Viewer', FALSE);
  if (RegSuccess = FALSE) then
  begin
    // Create standard entries
    Reg.OpenKey('Software\Topp\UTX-Viewer', TRUE);
    Reg.WriteString('Directory', 'C:\');
    Reg.WriteString('SaveDir', 'C:\');
    Reg.WriteInteger('JPEG-Compression', 70);
  end
  else
  begin
    //Some user update from Version 1.0/2.0 (some entries didn't exist in those versions)
    if ( Reg.ValueExists('JPEG-Compression') = FALSE) then
      Reg.WriteInteger('JPEG-Compression', 70);
    if ( Reg.ValueExists('Directory') = FALSE) then
      Reg.WriteString('Directory', 'C:\');
    if ( Reg.ValueExists('SaveDir') = FALSE) then
      Reg.WriteString('SaveDir', 'C:\');

    JPEGComp   := Reg.ReadInteger('JPEG-Compression');
    Directory  := Reg.ReadString('Directory');
      if ( not IsPathDelimiter(Directory, Length(Directory)) ) then Directory := Directory + '\';
    SaveDir    := Reg.ReadString('SaveDir');
      if ( not IsPathDelimiter(SaveDir, Length(SaveDir)) ) then SaveDir := SaveDir + '\';
  end;
  Reg.Free;

  //Set Texture-Directory
  UpdatePackageList;

  //Make "View Packages" Form current
  MainPageControl.ActivePage := TabSheet1;
  // Disable "Texture Details" at startup
  MainPageControl.Pages[1].TabVisible := FALSE;

  //Disable scroll-bar at startup
  PreviewUpDown.Enabled := FALSE;

  //change caption of the window
  Caption := 'UTX-Viewer ' + Version + ' - ' + Directory;
  ViewerLabel.Caption := 'About - UTX-Viewer ' + Version;
end;

//OnDestroy
procedure TMainForm.FormDestroy(Sender: TObject);
begin
  //Free UTPackage-object
  UTPackage.Free;
end;

procedure TMainForm.UpdatePackageList;
begin
  AvailPackages.Directory := Directory;
  AvailPackages.Update;

  Caption := 'UTX-Viewer ' + Version + ' - ' + Directory;
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//View Packages Tab

procedure TMainForm.AvailPackagesClick(Sender: TObject);
var
  i     : integer;
begin
  //Setup everything
  GroupList.Clear;

  // Enable "Texture Details" when first package is selected
  MainPageControl.Pages[1].TabVisible := TRUE;

  //Free PackageObject for use
  UTPackage.Free;

  UTPackage := TUTPackage.Create;

  IsLoaded := UTPackage.Load(AvailPackages.FileName);
  if (IsLoaded = FALSE) then
  begin
    UTPackage.Free;
    MessageDlg('Package ' + AvailPackages.FileName + ' could not be loaded', mtError, [mbOK], 0);
  end;

  for i:=0 to UTPackage.GroupCount-1 do
    GroupList.Items.Add(UTPackage.Group[i].Name);
  //automatically show [ALL] textures
  GroupList.ItemIndex := GroupList.Items.Count-1;
  GroupListClick(Application);;
  GroupList.Sorted := TRUE;

  //Print infos on Package to screen
  PackageVersion.Caption := IntToStr(UTPackage.PkgVer);
  GroupCount.Caption := IntToStr(UTPackage.GroupCount);
  TextureCount.Caption := IntToStr(UTPackage.TextureCount);
  FileSize.Caption := FloatToStrF(UTPackage.PackageSize/(1024*1024), ffFixed, 2, 2) + ' MB';

  //Activate Scrollbar
  PreviewUpDown.Enabled := TRUE;
end;

procedure TMainForm.GroupListClick(Sender: TObject);
var
  i,j       : integer;
begin
  //RePaint GroupList (looks nicer)
  GroupList.Sorted := TRUE;
  GroupList.RePaint;

  //Display previews
  for i:=0 to GroupList.Items.Count-1 do
    if (GroupList.Selected[i] = TRUE) then
    begin
      for j:=0 to UTPackage.GroupCount-1 do
        if (GroupList.Items.Strings[i] = UTPackage.Group[j].Name) then
        begin
          //Init scroll-bar
          PreviewUpDown.Min := 0;
          PreviewUpDown.Max := UTPackage.Group[j].Entries.Count;
          PreviewUpDown.SmallChange := 9;
          PreviewUpDown.LargeChange := 9;
          PreviewUpDown.Position := 0;

          GroupIndex := j;

          DrawPreviews(PreviewUpDown.Position);

          break;
      end;
    end;
end;

procedure TMainForm.PreviewUpDownChange(Sender: TObject);
begin
  if (PreviewUpDown.Position >= UTPackage.Group[GroupIndex].Entries.Count) then
    PreviewUpDown.Position := 0;
  DrawPreviews(PreviewUpDown.Position);
end;

procedure TMainForm.DrawPreviews;
var
  Position : integer;
begin
  Position := TextureIndex;

  //Draw previews
  begin
    if (Position < UTPackage.Group[GroupIndex].Entries.Count) then
    begin
      UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[Position], 128);
      Image0.Picture.Bitmap := UTPackage.NormalTexture.B;
      Image0.RePaint;
      Image0.Show;
      PreviewDesc0.Caption := '(' + IntToStr(Position+1) + '/' + IntToStr(UTPackage.Group[GroupIndex].Entries.Count) + ')'
                                  + ' - ' + UTPackage.NormalTexture.TextureName;
      PreviewDesc0.RePaint;
      Position := Position + 1;
    end
    else
    begin
      Image0.Hide;
      PreviewDesc0.Caption := '';
    end;
    if (Position < UTPackage.Group[GroupIndex].Entries.Count) then
    begin
      UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[Position], 128);
      Image1.Picture.Bitmap := UTPackage.NormalTexture.B;
      Image1.Show;
      Image1.RePaint;
      PreviewDesc1.Caption := '(' + IntToStr(Position+1) + '/' + IntToStr(UTPackage.Group[GroupIndex].Entries.Count) + ')'
                                 + ' - ' + UTPackage.NormalTexture.TextureName;
      PreviewDesc1.RePaint;
      Position := Position + 1;
    end
    else
    begin
      Image1.Hide;
      PreviewDesc1.Caption := '';
    end;
    if (Position < UTPackage.Group[GroupIndex].Entries.Count) then
    begin
      UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[Position], 128);
      Image2.Picture.Bitmap := UTPackage.NormalTexture.B;
      Image2.Show;
      Image2.RePaint;
      PreviewDesc2.Caption := '(' + IntToStr(Position+1) + '/' + IntToStr(UTPackage.Group[GroupIndex].Entries.Count) + ')'
                                  + ' - ' + UTPackage.NormalTexture.TextureName;
      PreviewDesc2.RePaint;
      Position := Position + 1;
    end
    else
    begin
      Image2.Hide;
      PreviewDesc2.Caption := '';
    end;
    if (Position < UTPackage.Group[GroupIndex].Entries.Count) then
    begin
      UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[Position], 128);
      Image3.Picture.Bitmap := UTPackage.NormalTexture.B;
      Image3.Show;
      Image3.RePaint;
      PreviewDesc3.Caption := '(' + IntToStr(Position+1) + '/' + IntToStr(UTPackage.Group[GroupIndex].Entries.Count) + ')'
                                 + ' - ' + UTPackage.NormalTexture.TextureName;
      PreviewDesc3.RePaint;
      Position := Position + 1;
    end
    else
    begin
      Image3.Hide;
      PreviewDesc3.Caption := '';
    end;
    if (Position < UTPackage.Group[GroupIndex].Entries.Count) then
    begin
      UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[Position], 128);
      Image4.Picture.Bitmap := UTPackage.NormalTexture.B;
      Image4.Show;
      Image4.RePaint;
      PreviewDesc4.Caption := '(' + IntToStr(Position+1) + '/' + IntToStr(UTPackage.Group[GroupIndex].Entries.Count) + ')'
                                  + ' - ' + UTPackage.NormalTexture.TextureName;
      PreviewDesc4.RePaint;
      Position := Position + 1;
    end
    else
    begin
      Image4.Hide;
      PreviewDesc4.Caption := '';
    end;
    if (Position < UTPackage.Group[GroupIndex].Entries.Count) then
    begin
      UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[Position], 128);
      Image5.Picture.Bitmap := UTPackage.NormalTexture.B;
      Image5.Show;
      Image5.RePaint;
      PreviewDesc5.Caption := '(' + IntToStr(Position+1) + '/' + IntToStr(UTPackage.Group[GroupIndex].Entries.Count) + ')'
                                  + ' - ' + UTPackage.NormalTexture.TextureName;
      PreviewDesc5.RePaint;
      Position := Position + 1;
    end
    else
    begin
      Image5.Hide;
      PreviewDesc5.Caption := '';
    end;
    if (Position < UTPackage.Group[GroupIndex].Entries.Count) then
    begin
      UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[Position], 128);
      Image6.Picture.Bitmap := UTPackage.NormalTexture.B;
      Image6.Show;
      Image6.RePaint;
      PreviewDesc6.Caption := '(' + IntToStr(Position+1) + '/' + IntToStr(UTPackage.Group[GroupIndex].Entries.Count) + ')'
                                  + ' - ' + UTPackage.NormalTexture.TextureName;
      PreviewDesc6.RePaint;
      Position := Position + 1;
    end
    else
    begin
      Image6.Hide;
      PreviewDesc6.Caption := '';
    end;
    if (Position < UTPackage.Group[GroupIndex].Entries.Count) then
    begin
      UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[Position], 128);
      Image7.Picture.Bitmap := UTPackage.NormalTexture.B;
      Image7.Show;
      Image7.RePaint;
      PreviewDesc7.Caption := '(' + IntToStr(Position+1) + '/' + IntToStr(UTPackage.Group[GroupIndex].Entries.Count) + ')'
                                  + ' - ' + UTPackage.NormalTexture.TextureName;
      PreviewDesc7.RePaint;
      Position := Position + 1;
    end
    else
    begin
      Image7.Hide;
      PreviewDesc7.Caption := '';
    end;
    if (Position < UTPackage.Group[GroupIndex].Entries.Count) then
    begin
      UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[Position], 128);
      Image8.Picture.Bitmap := UTPackage.NormalTexture.B;
      Image8.Show;
      Image8.RePaint;
      PreviewDesc8.Caption := '(' + IntToStr(Position+1) + '/' + IntToStr(UTPackage.Group[GroupIndex].Entries.Count) + ')'
                                + ' - ' + UTPackage.NormalTexture.TextureName;
      PreviewDesc8.RePaint;
      //Position := Position + 1; //not necessary
    end
    else
    begin
      Image8.Hide;
      PreviewDesc8.Caption := '';
    end;
  end;
end;

// Search function

procedure TMainForm.btnSearchClick(Sender: TObject);
begin
  if edbSearch.text = '' then
  begin
    btnSearch.Caption:='Package &Search';
    AvailPackages.Mask := '*.u*';
    AvailPackages.Update;
  end
 else
  begin
    AvailPackages.Mask := '*'+EdbSearch.text+'*.u*';
    AvailPackages.Update;
    btnSearch.Caption:='&Show All';
    EdbSearch.text:='';
  end;
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Texture Popup

//------------------------------------
//Get TextureIndex of selected texture
procedure TMainForm.Image0MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
    SelTexture := PreviewUpDown.Position + 0;
end;
procedure TMainForm.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
    SelTexture := PreviewUpDown.Position + 1;
end;
procedure TMainForm.Image2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
    SelTexture := PreviewUpDown.Position + 2;
end;
procedure TMainForm.Image3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
    SelTexture := PreviewUpDown.Position + 3;
end;
procedure TMainForm.Image4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
    SelTexture := PreviewUpDown.Position + 4;
end;
procedure TMainForm.Image5MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
    SelTexture := PreviewUpDown.Position + 5;
end;
procedure TMainForm.Image6MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
    SelTexture := PreviewUpDown.Position + 6;
end;
procedure TMainForm.Image7MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
    SelTexture := PreviewUpDown.Position + 7;
end;
procedure TMainForm.Image8MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
    SelTexture := PreviewUpDown.Position + 8;
end;

//-------------
// Export

//Export to BMP
procedure TMainForm.ExporttoBMP1Click(Sender: TObject);
var
  SaveBMP : TBitmap;
begin
  /////////////////
  //NORMAL TEXTURES
  UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[SelTexture], 512); //Maximum supported texture size is 512*512
  SaveBMP := UTPackage.NormalTexture.B;
  SaveBMP.SaveToFile(SaveDir + UTPackage.Group[GroupIndex].Entries.Strings[SelTexture] + '.bmp');
end;
//Export to JPEG
procedure TMainForm.ExporttoJPEG1Click(Sender: TObject);
var
  SaveJPEG : TJPEGImage;
begin
  /////////////////
  //NORMAL TEXTURES
  UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[SelTexture], 512); //Maximum supported texture size is 512*512
  SaveJPEG := TJPEGImage.Create;
  SaveJPEG.Assign(UTPackage.NormalTexture.B);
  SaveJPEG.CompressionQuality := JPEGComp;
  SaveJPEG.Compress;
  SaveJPEG.SaveToFile(SaveDir + UTPackage.Group[GroupIndex].Entries.Strings[SelTexture] + '.jpg');
  SaveJPEG.Free;
end;
// Export to PCX
procedure TMainForm.ExporttoPCX1Click(Sender: TObject);
var
  SavePCX : TPCXBitmap;
begin
  /////////////////
  //NORMAL TEXTURES
  UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[SelTexture], 512); //Maximum supported texture size is 512*512
  SavePCX := TPCXBitmap.Create;
  SavePCX.Assign(UTPackage.NormalTexture.B);
  SavePCX.SaveToFile(SaveDir + UTPackage.Group[GroupIndex].Entries.Strings[SelTexture] + '.pcx');
  SavePCX.Free;
end;

//-------------
//TiledPreview
procedure TMainForm.TiledPreview1Click(Sender: TObject);
begin
  /////////////////
  //NORMAL TEXTURES
  UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[SelTexture], 512); //Maximum supported texture size is 512*512

  TiledPreviewForm := TTiledPreviewForm.Create(Application);
  TiledPreviewForm.ShowModal(UTPackage.NormalTexture.B);
end;

//-------------
//Full preview
procedure TMainForm.ShowLargestMipMap1Click(Sender: TObject);
begin
  /////////////////
  //NORMAL TEXTURES
  UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[SelTexture], 512); //Maximum supported texture size is 512*512

  FullPreviewForm := TFullPreviewForm.Create(Application);
  FullPreviewForm.ShowModal(UTPackage.NormalTexture.B);
end;

//-------------------
// Show TextureDetails
procedure TMainForm.ShowTextureDetails1Click(Sender: TObject);
begin
  MainPageControl.ActivePage := MainPageControl.Pages[1]; // Make "Texture Details"-Tab current
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// "Texture Details" Tab

// Init and finish stuff
procedure TMainForm.TabSheet2Enter(Sender: TObject);
var
  GenericProperties          : TStrings;
begin
  // Init
  ExitBtn.Enabled := FALSE;                // Disable exit button
  GenericProperties := TStringList.Create;
  PropertyMemo.Lines.Clear;

  // Load texture and assign it into TImage ( later replaced by OpenGL stuff )
  UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[SelTexture], 256);
  //DetailImage.Picture.Assign(UTPackage.NormalTexture.B);

  // Fill in infos on current texture
  with UTPackage do
  begin
    TextureName.Caption          := NormalTexture.TextureName;
    TexturePackage.Caption       := ExtractFileName(Name);
    TextureDimensions.Caption    := IntToStr(NormalTexture.USize) + ' x ' + IntToStr(NormalTexture.VSize);
    TextureSize.Caption          := FloatToStrF(NormalTexture.SerialSize/(1024), ffFixed, 4, 2) + ' KB';
    TextureMipMapCount.Caption   := IntToStr(NormalTexture.MipMapCount);
    case NormalTexture.bMasked of
      TRUE  : TexturebMasked.Caption := 'TRUE';
      FALSE : TexturebMasked.Caption := 'FALSE';
    end;
    case NormalTexture.IsAnimated of
      TRUE  :
        begin
          TextureIsAnimated.Caption := 'TRUE';
          LabelNumberofFrames.Enabled := TRUE;
          LabelMinFrameRate.Enabled := TRUE;
          LabelMaxFrameRate.Enabled := TRUE;
          TextureFrameCount.Enabled := TRUE;
          TextureMinFrameRate.Enabled := TRUE;
          TextureMaxFrameRate.Enabled := TRUE;
        end;
      FALSE :
        begin
          TextureIsAnimated.Caption := 'FALSE';
          LabelNumberofFrames.Enabled := FALSE;
          LabelMinFrameRate.Enabled := FALSE;
          LabelMaxFrameRate.Enabled := FALSE;
          TextureFrameCount.Enabled := FALSE;
          TextureMinFrameRate.Enabled := FALSE;
          TextureMaxFrameRate.Enabled := FALSE;
        end;
    end;
  end;

  // Create OpenGL windows
  with OpenGLPanel do
    CreateOpenGL(Handle, Width, Height);
  // Load textures and read generic properties
  GenericProperties.AddStrings(LoadTextures(GroupIndex, SelTexture, UTPackage.NormalTexture.IsAnimated));
  PropertyMemo.Lines.AddStrings( GenericProperties );

  // FrameCount info (needs all textures to be loaded)
  TextureFrameCount.Caption := IntTostr(FrameCount);
  TextureMinFrameRate.Caption := FloatToStr(MinFrameRate);
  TextureMaxFrameRate.Caption := FloatToStr(MinFrameRate);
  // Adjust timer to FrameRate
  if ( MinFrameRate <> 0 ) then
    OpenGLTimer.Interval := Round(1000 / MinFrameRate);
  if ( MaxFrameRate <> 0 ) then
    OpenGLTimer.Interval := Round(1000 / MaxFrameRate);
  if (MinFrameRate + MaxFrameRate = 0 ) then
      OpenGLTimer.Interval := 40;

  // Finish
  GenericProperties.Free;
end;
procedure TMainForm.TabSheet2Exit(Sender: TObject);
begin
  // Re-enable Exit button
  ExitBtn.Enabled := TRUE;
  // Destroy OpenGL
  KillOpenGL;
end;

// Timer to update OpenGL
procedure TMainForm.OpenGLTimerTimer(Sender: TObject);
begin
  // Update Output
  if ( MainPageControl.ActivePage.Caption = '&Texture Details' ) then
    DrawGL;
end;

// Zoom In & Out of texture
procedure TMainForm.BtnZoomInClick(Sender: TObject);
begin
  ZoomGL(0.15);
end;
procedure TMainForm.BtnZoomOutClick(Sender: TObject);
begin
  ZoomGL(-0.15);
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//"Create Package"-Tab

//Init
procedure TMainForm.TabSheet3Enter(Sender: TObject);
begin
  UTSavePackage.Free;
  UTSavePackage := TUTPackage.Create;
  UTSavePackage.MODE := PKG_WRITE;
end;

//Add group to list
procedure TMainForm.AddGroupBtnClick(Sender: TObject);
begin
  //Show "Specify Group-Name Dialog
  AddGroupDialog.ShowModal;

  //Add new group
  if ( AddGroupDialog.GroupName <> '' ) then
  begin

    UTSavePackage.AddGroup[UTSavePackage.GroupCount].GroupName := AddGroupDialog.GroupName;
    GroupListBox.Items.Add(UTSavePackage.AddGroup[UTSavePackage.GroupCount].GroupName);
    UTSavePackage.GroupCount := UTSavePackage.GroupCount + 1;
  end;

  SaveUTXBtn.Enabled := TRUE;
end;

//Remove GroupEntry
procedure TMainForm.RemoveGroupBtnClick(Sender: TObject);
var
  i       : integer;
  DelGroup: integer;
begin
  //-1 = no group selected
  DelGroup := -1;

  //Check if there is at least one group
  if ( UTSavePackage.GroupCount <> 0) then
  begin
    //Find selected group
    for i:=0 to UTSavePackage.GroupCount-1 do
      if ( GroupListBox.Selected[i] = TRUE ) then
        DelGroup := i;

    //check if a group is really selected
    if ( DelGroup <> -1) then
      for i:=DelGroup to UTSavePackage.GroupCount-1 do
      begin
        //Free deleted group (first thing to do)
        if ( i = DelGroup ) then
        begin
          UTSavePackage.AddGroup[i].GroupName := '';
          UTSavePackage.AddGroup[i].TextureName.Clear;
          UTSavePackage.AddGroup[i].FileName.Clear;
        end;

        //Move following group into this place
        UTSavePackage.AddGroup[i].GroupName := UTSavePackage.AddGroup[i+1].GroupName;
        UTSavePackage.AddGroup[i].TextureName.AddStrings(UTSavePackage.AddGroup[i+1].TextureName);
        UTSavePackage.AddGroup[i].FileName.AddStrings(UTSavePackage.AddGroup[i+1].FileName);

        //Free moved entry
        UTSavePackage.AddGroup[i+1].GroupName := '';
        UTSavePackage.AddGroup[i+1].TextureName.Clear;
        UTSavePackage.AddGroup[i+1].FileName.Clear;
      end;
  end;
  UTSavePackage.GroupCount := UTSavePackage.GroupCount - 1;

  //Update GroupListBox
  GroupListBox.Clear;
  for i:=0 to UTSavePackage.GroupCount-1 do
    if ( UTSavePackage.AddGroup[i].GroupName <> '' ) then
      GroupListBox.Items.Add(UTSavePackage.AddGroup[i].GroupName);
  //Update TextureListBox
  TextureListBox.Clear;

  //Disable "Remove Group"-btn and "Save UTX"-Btn if no group left
  if ( UTSavePackage.GroupCount = 0 ) then
  begin
    RemoveGroupBtn.Enabled := FALSE;
    SaveUTXBtn.Enabled := FALSE;
  end;
  //Disable texture-buttons
  AddTextureBtn.Enabled := FALSE;
  RemoveTextureBtn.Enabled := FALSE;

  CreateUTXImage.Picture.Assign(nil);
  TextureProperties.Enabled := FALSE;
end;

//GroupList clicked
procedure TMainForm.GroupListBoxClick(Sender: TObject);
var
  i       : integer;
begin
  for i:=0 to UTSavePackage.GroupCount-1 do
    if ( GroupListBox.Selected[i] = TRUE ) then
      GroupIndex := i;
  UpdateTextureList;

  //(Re-)Enable Remove-group-btn
  RemoveGroupBtn.Enabled := TRUE;
  //Enable texture-buttons
  AddTextureBtn.Enabled := TRUE;
end;

//AddTexture to list
procedure TMainForm.AddTextureBtnClick(Sender: TObject);
var
  i,k        : integer;
  LastSlash  : integer;
  TextureName: string;
begin
  frmOpenPcx.ShowModal;
  if frmOpenPcx.Files.Count <> 0 then
  begin
    for i:=0 to frmOpenPcx.Files.Count-1 do
    begin                     
      //Cut path and extension
      for k:=0 to length(frmOpenPcx.Files.Strings[i]) do
        if ( frmOpenPcx.Files.Strings[i][k] = '\' ) then
          LastSlash := k;
      TextureName := frmOpenPcx.Files.Strings[i];
      Delete(TextureName, 1, LastSlash);
      Delete(TextureName, length(TextureName)-3, 4);

      UTSavePackage.AddGroup[GroupIndex].TextureName.Add(TextureName);
      UTSavePackage.AddGroup[GroupIndex].FileName.Add(frmOpenPcx.Files.Strings[i]);
      UTSavePackage.AddGroup[GroupIndex].HasMipMaps.Add('TRUE');  //NormalTexture
      UTSavePackage.AddGroup[GroupIndex].bMasked.Add('FALSE');
    end;
    RemoveTextureBtn.Enabled := TRUE;
  end;

  UpdateTextureList;
end;

//Remove texture from list
procedure TMainForm.RemoveTextureBtnClick(Sender: TObject);
var
  i       : integer;
begin
  //Get selected texture
  for i:=0 to TextureListBox.Items.Count-1 do
    if ( TextureListBox.Selected[i] = TRUE ) then
      SelTexture := i;

  //Delete all entries of texture
  UTSavePackage.AddGroup[GroupIndex].TextureName.Delete(SelTexture);
  UTSavePackage.AddGroup[GroupIndex].FileName.Delete(SelTexture);

  CreateUTXImage.Picture.Assign(nil);
  TextureProperties.Enabled := FALSE;

  RemoveTextureBtn.Enabled := FALSE;

  UpdateTextureList;
end;

procedure TMainForm.TextureListBoxClick(Sender: TObject);
var
  Bitmap    : TPCXBitmap;
  H, W, Tmp : Integer;
begin
  //Show selected texture
  Bitmap := TPCXBitmap.Create;
  CreateUTXImage.Stretch:=False;
  CreateUTXImage.Width:=256; CreateUTXImage.Height:=256;
  Bitmap.LoadFromFile(Filename);
  w:=Bitmap.Width; h:=Bitmap.Height;
  // Display image dimensions
  TextureDimension.Caption:='Size: '+IntToStr(W)+'x'+IntToStr(H);
  // If height or width > 256 then Scale to fit
  If (h > w) then tmp:=h else tmp:=w;
  If Tmp > 256 then
  Begin
    While tmp > 256 do
    Begin
      w:=(w Div 2); h:=(h div 2);
      tmp:=(Tmp Div 2);
    End;
    // Define new Image preview dimensions;
    CreateUTXImage.Width:=w; CreateUTXImage.Height:=h; CreateUTXImage.Stretch:=True;
    TextureDimension.Caption:=TextureDimension.Caption+' (Scaled to fit)';
  End;
  // diaply the Picture
  CreateUTXImage.Picture.Assign(Bitmap);

  Bitmap.Free;

  //Show options
  if ( UTSavePackage.AddGroup[GroupIndex].HasMipMaps.Strings[TextureListBox.ItemIndex] = 'TRUE' ) then
    ShallGenerateMipMaps.Checked := TRUE
  else
    ShallGenerateMipMaps.Checked := FALSE;
  if ( UTSavePackage.AddGroup[GroupIndex].bMasked.Strings[TextureListBox.ItemIndex] = 'TRUE' ) then
    bMasked.Checked := TRUE
  else
    bMasked.Checked := FALSE;

  RemoveTextureBtn.Enabled := TRUE;
  TextureProperties.Enabled := TRUE;
end;

//----------------
//Misc

//Updates the texturelist
procedure TMainForm.UpdateTextureList;
var
  i       : integer;
begin
//  TextureListBox
  TextureListBox.Clear;

  for i:=0 to UTSavePackage.AddGroup[GroupIndex].TextureName.Count-1 do
  begin
    TextureListBox.Items.Add(UTSavePackage.AddGroup[GroupIndex].TextureName.Strings[i]);
  end;
end;

//Save package to disk
procedure TMainForm.SaveUTXBtnClick(Sender: TObject);
begin
  SavePackageDialog.InitialDir := SaveDir;

  if ( SavePackageDialog.Execute = TRUE ) then
  begin
    //Save package to disk
    UTSavePackage.Save(SavePackageDialog.FileName);
    //Update PackageList in "View Packages"-Tab
    UpdatepackageList;
  end;
end;

//Reset everything
procedure TMainForm.ResetUTXBtnClick(Sender: TObject);
begin
  UTSavePackage.Free;
  UTSavePackage := TUTPackage.Create;

  GroupListBox.Clear;
  TextureListBox.Clear;

  CreateUTXImage.Picture.Assign(nil);
  TextureProperties.Enabled := FALSE;

  //Disable Remove-group-btn
  RemoveGroupBtn.Enabled := FALSE;
  //Disable texture-buttons
  AddTextureBtn.Enabled := FALSE;
  RemoveTextureBtn.Enabled := FALSE;
end;

//Options
procedure TMainForm.ShallGenerateMipMapsClick(Sender: TObject);
begin
  if ( ShallGenerateMipMaps.Checked = TRUE ) then
    UTSavePackage.AddGroup[GroupIndex].HasMipMaps.Strings[TextureListBox.ItemIndex] := 'TRUE'
  else
    UTSavePackage.AddGroup[GroupIndex].HasMipMaps.Strings[TextureListBox.ItemIndex] := 'FALSE';
end;

procedure TMainForm.bMaskedClick(Sender: TObject);
begin
  if ( bMasked.Checked = TRUE ) then
    UTSavePackage.AddGroup[GroupIndex].bMasked.Strings[TextureListBox.ItemIndex] := 'TRUE'
  else
    UTSavePackage.AddGroup[GroupIndex].bMasked.Strings[TextureListBox.ItemIndex] := 'FALSE';
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//Preference-Tab

// Init and exit stuff
procedure TMainForm.TabSheet4Enter(Sender: TObject);
begin
  SaveDirEdit.Text := SaveDir;
end;
procedure TMainForm.TabSheet4Exit(Sender: TObject);
begin
  // nothing yet !
end;

// User changes the current Directory
procedure TMainForm.ChDirBtnClick(Sender: TObject);
var
  Reg     : TRegistry;
begin
  //Set new Directory
  BrowseDlg.Selection := Directory;
  
  if ( BrowseDlg.Execute ) then
  begin
    Directory := BrowseDlg.Selection;

    //Save current game to registry
    Reg := TRegistry.Create;
    Reg.OpenKey('Software\Topp\UTX-Viewer', FALSE);
    Reg.WriteString('Directory', Directory);
    Reg.Free;
    // Fordy - If Game type changes & a Package search has been performed then
    // reset the Search to show all packages.
      btnSearch.Caption:='Package &Search';
      AvailPackages.Mask := '*.u*';

    UpdatePackageList;
  end;
end;

//JPEG-Compression
procedure TMainForm.JPEGCompTrackBarChange(Sender: TObject);
var
  Reg     : TRegistry;
begin
  JPEGComp := JPEGCompTrackBar.Position;
  JPEGCompEdit.Text := IntToStr(JPEGComp);
  //Save current game to registry
  Reg := TRegistry.Create;
  Reg.OpenKey('Software\Topp\UTX-Viewer', FALSE);
  Reg.WriteInteger('JPEG-Compression', JPEGComp);
  Reg.Free;
end;

procedure TMainForm.JPEGCompEditChange(Sender: TObject);
var
  Reg     : TRegistry;
begin
  if ( JPEGCompEdit.Text <> '') then
  begin
    JPEGComp := StrToInt(JPEGCompEdit.Text);
    JPEGCompTrackBar.Position := JPEGComp;
    //Save current game to registry
    Reg := TRegistry.Create;
    Reg.OpenKey('Software\Topp\UTX-Viewer', FALSE);
    Reg.WriteInteger('JPEG-Compression', JPEGComp);
    Reg.Free;
  end;
end;

procedure TMainForm.ChSaveDirBtnClick(Sender: TObject);
var
  Reg     : TRegistry;
begin
  BrowseDlg.Selection := SaveDir;

  if ( BrowseDlg.Execute ) then
  begin
    SaveDir := BrowseDlg.Selection;
    SaveDirEdit.Text := SaveDir;

    //Save current game to registry
    Reg := TRegistry.Create;
    Reg.OpenKey('Software\Topp\UTX-Viewer', FALSE);
    Reg.WriteString('SaveDir', SaveDir);
    Reg.Free;
  end;
end;


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

// Fordy - Exit the program
procedure TMainForm.ExitBtnClick(Sender: TObject);
begin
  close;
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Debug stuff

procedure TMainForm.testBtnClick(Sender: TObject);
var
  i : integer;
begin
  with CreateUTXProgressBar do
  begin
    Visible := TRUE;
    Min := 0;
    Max := UTPackage.Group[GroupIndex].Entries.Count;
    Position := 0;
    Step := 1;
  end;

  for i:=0 to UTPackage.Group[GroupIndex].Entries.Count-1 do
  begin
    UTPackage.LoadNormalTexture(UTPackage.Group[GroupIndex].Entries.Strings[i], 128);
    CreateUTXProgressBar.StepIt;
  end;
end;

end.
