program UTPackage;

uses
  Forms,
  Main in 'Main.pas' {MainForm},
  PackageFormat in 'PackageFormat.pas',
  PkgAux in 'PkgAux.pas',
  NormalTexture in 'NormalTexture.pas',
  TiledPreviewDlg in 'TiledPreviewDlg.pas' {TiledPreviewForm},
  FullPreviewDlg in 'FullPreviewDlg.pas' {FullPreviewForm},
  ErrorBox in 'ErrorBox.pas' {frmError},
  Pcxctrl in 'PCXCtrl.pas',
  OpenGLPreview in 'OpenGLPreview.pas',
  Objects in 'Objects.pas',
  AddGroupDlg in 'AddGroupDlg.pas' {AddGroupDialog},
  OpenPcxDlg in 'OpenPcxDlg.pas' {frmOpenPCX};

{$R *.RES}

begin
  Application.Initialize;
  Application.Title := 'UTX-Viewer';
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TTiledPreviewForm, TiledPreviewForm);
  Application.CreateForm(TFullPreviewForm, FullPreviewForm);
  Application.CreateForm(TfrmError, frmError);
  Application.CreateForm(TAddGroupDialog, AddGroupDialog);
  Application.CreateForm(TfrmOpenPCX, frmOpenPCX);
  Application.Run;
end.
